/**
 * 
 */
package org.solol.mmseg.core;

/**
 * @author solo L
 * 
 */
public abstract class AlgorithmFactory {

	public static final String FACTORY_PROPERTY = "org.solol.mmseg.AlgorithmFactory";

	public static final String FACTORY_DEFAULT = "org.solol.mmseg.internal.AlgorithmFactoryImpl";

	private static AlgorithmFactory factory = null;

	public static AlgorithmFactory getFactory() throws ConfigurationException {
		if (factory == null) {
			ClassLoader contextClassLoader = AlgorithmFactory.class
					.getClassLoader();
			factory = createFactory(FACTORY_DEFAULT, contextClassLoader);
		}

		return factory;
	}

	protected static AlgorithmFactory createFactory(String factoryClass,
			ClassLoader classLoader) throws ConfigurationException {

		Class logFactoryClass;

		try {
			logFactoryClass = classLoader.loadClass(factoryClass);
			return (AlgorithmFactory) logFactoryClass.newInstance();
		} catch (ClassNotFoundException e) {
			throw new ConfigurationException(e);
		} catch (InstantiationException e) {
			throw new ConfigurationException(e);
		} catch (IllegalAccessException e) {
			throw new ConfigurationException(e);
		}
	}

	public abstract IAlgorithm createAlgorithm() throws AlgorithmException;

	public abstract IAlgorithm createAlgorithm(String type)
			throws AlgorithmException;
}
