/**
 * 
 */
package org.solol.mmseg.internal;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.solol.mmseg.core.IChunk;
import org.solol.mmseg.core.IRule;

/**
 * @author solo L
 * 
 */
public class MMRule implements IRule {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.solol.mmseg.core.IRule#invoke()
	 */
	public final IChunk[] invoke(final IChunk[] chunks) {
		MMRuleComparator[] orderedChunks = new MMRuleComparator[chunks.length];

		for (int i = 0; i < chunks.length; i++) {
			orderedChunks[i] = new MMRuleComparator(chunks[i]);
		}

		Arrays.sort(orderedChunks);

		int index = 0;
		int maxLength = orderedChunks[index].getChunk().getLength();

		List list = new ArrayList(1);
		list.add(orderedChunks[index].getChunk());

		index++;

		while (index < orderedChunks.length) {

			if (orderedChunks[index].getChunk().getLength() == maxLength) {
				list.add(orderedChunks[index].getChunk());
			} else {
				break;
			}
			index++;
		}

		IChunk[] maxLengthChunks = new IChunk[list.size()];
		list.toArray(maxLengthChunks);		

		return maxLengthChunks;
	}

	static class MMRuleComparator implements Comparable {

		private IChunk chunk;

		public MMRuleComparator(IChunk chunk) {
			this.chunk = chunk;
		}

		public IChunk getChunk() {
			return chunk;
		}

		public int compareTo(Object obj) {
			IChunk another = ((MMRuleComparator) obj).getChunk();

			return another.getLength() - chunk.getLength();
		}

	}

}
