/**
 * 
 */
package org.solol.mmseg.test;

import org.solol.mmseg.core.IWord;
import org.solol.mmseg.internal.Word;

import junit.framework.TestCase;

/**
 * @author solo L
 * 
 */
public class WordTest extends TestCase {
	
	IWord word1 = null;
	IWord word2 = null;
	IWord word3 = null;

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		word1 = new Word("国际化",Word.CJK_WORD);
		word2 = new Word("国际化",Word.CJK_WORD);
		word3 = new Word("国际",Word.CJK_WORD);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		word1 = null;
		word2 = null;
		word3 = null;
	}

	/**
	 * Test method for
	 * {@link org.solol.mmseg.internal.Word#Word(java.lang.String)}.
	 */
	public final void testWord() {
		assertNotNull(word1);
		assertNotNull(word2);
		assertNotNull(word3);		
	}

	/**
	 * Test method for {@link org.solol.mmseg.internal.Word#getLength()}.
	 */
	public final void testGetLength() {
		assertEquals(3, word1.getLength());
		assertEquals(3, word2.getLength());
		assertEquals(2, word3.getLength());
	}
	
	/**
	 * Test method for {@link org.solol.mmseg.internal.Word#getValue()}.
	 */
	public final void testGetValue() {
		assertEquals("国际化", word1.getValue());
		assertEquals("国际化", word2.getValue());
		assertEquals("国际", word3.getValue());
	}

	/**
	 * Test method for {@link org.solol.mmseg.internal.Word#equals()}.
	 */
	public final void testEquals() {
		
		assertTrue(word1.equals(word2));
		assertTrue(word2.equals(word1));
		
		assertFalse(word1.equals(word3));
		assertFalse(word3.equals(word1));
	}
	
	/**
	 * Test method for {@link org.solol.mmseg.internal.Word#getValue()}.
	 */
	public final void testHashCode() {
		assertTrue(word1.hashCode() == word2.hashCode());
		assertFalse(word1.hashCode() == word3.hashCode());
	}

}
